/**
  ******************************************************************************
  * @file    Project/Template/main.c
  * @author  MCD Application Team
  * @version V1.3.0
  * @date    07/14/2010
  * @brief   Main program body
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDIN THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 STMicroelectronics</center></h2>
  */ 
	
/* Includes ------------------------------------------------------------------*/
#include "stm8l15x.h"
#include "stm8l_discovery_lcd.h"
#include "discover_board.h"
#include "delay.h"
// #include "discover_functions.h"
#define OFFST 2
#define OFFEV4 5
/* LCD bar graph: used for display active function */
extern uint8_t t_bar[2]; // declared in stm8l_discovery_lcd.c
uint16_t cnt=0;
uint8_t cnt10=0,upd=0;

/** @addtogroup Template
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/

/* Private functions ---------------------------------------------------------*/

void mint2char(uint16_t number, uint16_t *p_tab)
{
  uint16_t units=0, tens=0, hundreds=0, thousands=0, misc=0;
	uint16_t i=0;
	
  units = number%10;
	number/=10;
  tens = number%10;
	number/=10;
  hundreds = number%10;
	number/=10;
  thousands = number%10;
	misc=number/10;
  
  *(p_tab+4) = units + 0x30;
  *(p_tab+3) = tens + 0x30;
  *(p_tab+2) = hundreds + 0x30;
  *(p_tab+1) = thousands + 0x30;
  *(p_tab) = misc + 0x30;

	while(*(p_tab+i)==0x30)
	{
		*(p_tab+i)=' ';
		i++;
		if(i==4) break;
	}
}

void convString(uint8_t* ptr,uint16_t *p_tab)
{
	uint8_t i=0,j=0;
	while(*(ptr+i)!='\0')
	{
		if(*(ptr+i)!='.')
		{
			*(p_tab+j)=*(ptr+i);
			i++; j++;
		}
		else
		{
			*(p_tab+j-1)+=DOT;
			i++;
		}
	}
	while(j<6)
	{
		*(p_tab+j)=' ';
		j++;
	}
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
void main(void)
{
  uint16_t tab[6];
	uint16_t cnt2=0;
	uint8_t lcdb=0,i=0;

	CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);
	EXTI_SetPinSensitivity(USER_GPIO_PIN, EXTI_Trigger_Falling);
//	EXTI_SetPinSensitivity(CTN_CNTEN_GPIO_PIN,EXTI_Trigger_Falling);
	EXTI_SetPinSensitivity(CTN_CNTEN_GPIO_PIN,EXTI_Trigger_Rising);
/* USER button init: GPIO set in input interrupt active mode */
	CLK_LSEConfig(CLK_LSE_ON);
	while (CLK_GetFlagStatus(CLK_FLAG_LSERDY) == RESET);
  GPIO_Init(BUTTON_GPIO_PORT,USER_GPIO_PIN, GPIO_Mode_In_FL_IT);
  GPIO_Init(CTN_GPIO_PORT,CTN_CNTEN_GPIO_PIN, GPIO_Mode_In_FL_IT);
//	GPIO_Init(WAKEUP_GPIO_PORT,ICC_WAKEUP_GPIO_PIN,GPIO_Mode_Out_PP_Low_Slow);
//	GPIO_ResetBits(WAKEUP_GPIO_PORT,ICC_WAKEUP_GPIO_PIN);

tab[5]=' ';
	LCD_GLASS_Init();
//  BAR1_ON;
	LCD_GLASS_DisplayString("INIT");
	delay_ms(500);
	CLK_RTCClockConfig(CLK_RTCCLKSource_LSE, CLK_RTCCLKDiv_1);
	CLK_PeripheralClockConfig(CLK_Peripheral_RTC, ENABLE);
	RTC_WakeUpCmd(DISABLE);
	RTC_WakeUpClockConfig(RTC_WakeUpClock_RTCCLK_Div16);
	RTC_SetWakeUpCounter(2047);
	RTC_ITConfig(RTC_IT_WUT, ENABLE);
	enableInterrupts();
//	RTC_SetWakeUpCounter(47);
	RTC_WakeUpCmd(ENABLE);

  /* Infinite loop */
  while (1)
  {
		if(upd)
		{
			upd=0;
			i++;
			cnt2+=cnt;
			if(i>cnt10)
			{
				if(cnt10) BAR0_ON; else BAR0_OFF;
				if(lcdb) {lcdb=0; BAR1_ON;} else {lcdb=1; BAR1_OFF;}
				mint2char(cnt2,tab);
				LCD_GLASS_DisplayStrDeci(tab);
				i=0; cnt2=0;
			}
		}
//		itmp+=1;
//		LCD_GLASS_DisplayString("MM");
//		mint2char(tmp,tab);
//		LCD_GLASS_DisplayStrDeci(tab);
//		delay_ms(100); tmp++;
  }
}

/**
  * @brief  Inserts a delay time.
  * @param  nCount: specifies the delay time length.
  * @retval None
  */

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */

/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/